'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var langYaml = require('@codemirror/lang-yaml');
var lr = require('@lezer/lr');
var highlight$1 = require('@lezer/highlight');
var language = require('@codemirror/language');
var common = require('@lezer/common');
var dotrain = require('@rainlanguage/dotrain');
var state = require('@codemirror/state');
var autocomplete = require('@codemirror/autocomplete');
var view = require('@codemirror/view');
var lint = require('@codemirror/lint');
var vscodeLanguageserverTextdocument = require('vscode-languageserver-textdocument');

// This file was generated by lezer-generator. You probably shouldn't edit it.
const FrontMatter = 1, ElisionMsg = 2;

const frontMatter = new lr.ExternalTokenizer((input, _stack) => {
    // 45 = -
    // 47 = /
    // 42 = *
    while (input.next >= 0) {
        if (input.next == 45 && input.peek(1) == 45 && input.peek(2) == 45) {
            input.acceptToken(FrontMatter);
            break;
        }
        else if (input.next == 42 && input.peek(1) == 47) {
            break;
        }
        input.advance();
    }
});
const elisionMsg = new lr.ExternalTokenizer((input, _stack) => {
    while (check(input)) {
        if (input.next == 33) {
            while (check(input)) {
                input.advance();
            }
            input.acceptToken(ElisionMsg);
            break;
        }
        input.advance();
    }
});
function check(input) {
    // 33 = !
    // 47 = /
    // 42 = *
    // 35 = #
    // 64 = @
    return input.next >= 0
        && input.next != 35
        && input.next != 64
        && !(input.next == 47 && input.peek(1) == 42);
}

const highlight = highlight$1.styleTags({
    FrontMatterSplitter: highlight$1.tags.comment,
    Number: highlight$1.tags.number,
    Placeholder: highlight$1.tags.unit,
    VariableName: highlight$1.tags.variableName,
    Opcode: highlight$1.tags.keyword,
    OpcodeWithOperand: highlight$1.tags.keyword,
    BlockComment: highlight$1.tags.comment,
    AngleBracketOpen: highlight$1.tags.keyword,
    AngleBracketClose: highlight$1.tags.keyword,
    ParenOpen: highlight$1.tags.keyword,
    ParenClose: highlight$1.tags.keyword,
    Assignment: highlight$1.tags.separator,
    Comma: highlight$1.tags.punctuation,
    Semi: highlight$1.tags.punctuation,
    Import: highlight$1.tags.meta,
    Binding: highlight$1.tags.className,
    Quote: highlight$1.tags.string,
    StringLiteral: highlight$1.tags.string,
    SubParser: highlight$1.tags.string,
    Pragma: highlight$1.tags.unit,
    ElisionMsg: highlight$1.tags.deleted,
});
const indent = language.indentNodeProp.add({
    Expression: language.delimitedIndent({ closing: ")", align: false }),
});
const fold = language.foldNodeProp.add({
    Expression: language.foldInside,
    BlockComment(tree) { return { from: tree.from + 2, to: tree.to - 2 }; }
});

// This file was generated by lezer-generator. You probably shouldn't edit it.
const parser = lr.LRParser.deserialize({
  version: 14,
  states: "$zQ!^QTOOP!eOSOOO#eQSO'#CrOOQO'#Co'#CoO#lQSO'#CnOOQO'#DR'#DROOQO'#Cx'#CxO#sQUO'#CxQ$zQSOOQ$zQSOOQYQSOOP%UOWO'#C_POOO)C>q)C>qOOQO'#Cy'#CyO%aQSO,59^O%hQSO,59^O%mQSO,59YOOQO,59Y,59YOOQO,59d,59dOOQO-E6v-E6vPOOO'#Cw'#CwP%tOWO,58yPOOO,58y,58yOOQO-E6w-E6wO&PQSO1G.xOOQO1G.x1G.xOOQO1G.t1G.tPOOO-E6u-E6uPOOO1G.e1G.eOOQO7+$d7+$d",
  stateData: "&[~OpOSqPQ~OTXOUTOVTOWTOXTOYTOZTO[TO]TO^TO_TO`TOdROgQOiUOjVO~OPYO~PYOqZO~OUTOVTOWTOXTOYTOZTO[TO]TO^TO_TO`TOdROgQO~Oh_O~P!jOaaO~P!jOQbOUlXVlXWlXXlXYlXZlX[lX]lX^lX_lX`lXdlXglXilXjlXnlX~OiUOjVO~P!jOrdOsdOtfO~OhhO~P!jOeiO~OajO~P!jOrdOsdOtlO~OemO~Odg`g^~",
  goto: "#`vPPPwPPPPPPPPPPPPPPz!UPP!`PPPP!j!p!xPPPPPPP#SR[PaTOQSWXY^`aSOQSWXY^`aROQSWXY^`QeZRkeUWOXYRcWQ^QQ`STg^`WUOWXYX]QS^`",
  nodeNames: "⚠ FrontMatter ElisionMsg BlockComment Program FrontMatterSplitter Semi Comma Assignment AngleBracketOpen Number StringLiteral SubParser Placeholder VariableName Quote Pragma ParenClose Expression OpcodeOpening Opcode ParenOpen OpcodeWithOperandOpening OpcodeWithOperand AngleBracketClose Import Binding",
  maxTerm: 37,
  propSources: [highlight,indent,fold],
  skippedNodes: [0,3,27],
  repeatNodeCount: 3,
  tokenData: "6O~RiXY!pYZ!p]^!ppq!prs#Rst#pwx$nxy%lyz%q|}%v}!O%{!P!Q&^!Q!R&i!R![']![!](P!]!^(U!^!_(Z!`!a(`!b!c(e!c!}*r!}#O+e#R#S,V#T#i*r#i#j,[#j#o*r~!uSp~XY!pYZ!p]^!ppq!p~#UTOr#Rrs#es;'S#R;'S;=`#j<%lO#R~#jOZ~~#mP;=`<%l#R~#uZj~OX#pZ]#p^p#pqx#pz|#p}![#p!_!`#p!a#Q#p#R;'S#p;'S;=`$h<%lO#p~$kP;=`<%l#p~$sZ_~OX$nZ]$n^p$nqx$nz|$n}![$n!_!`$n!a#Q$n#R;'S$n;'S;=`%f<%lO$n~%iP;=`<%l$n~%qOe~~%vOa~~%{OV~~&OP}!O&R~&UP}!O&X~&^OT~~&aPz{&d~&iOq~~&nPY~#l#m&q~&tR!Q![&}!c!i&}#T#Z&}~'SRY~!Q![&}!c!i&}#T#Z&}~'bQY~!Q!['h#X#Y'q~'kQ!Q!['h#X#Y'q~'tP!Q!['w~'|PY~!Q!['w~(UOW~~(ZOU~~(`OX~~(eOh~~(jVi~XY(eYZ(e]^(epq(e!Q!R)P!c!})q#T#o)q~)SP#l#m)V~)YR!Q![)c!c!i)c#T#Z)c~)hRi~!Q![)c!c!i)c#T#Z)c~)tWXY*^YZ*^]^*^pq*^}!O)q!Q![)q!c!})q#T#o)q~*cTi~XY*^YZ*^]^*^pq*^!Q!R)P~*wU^~xy+Z}!O*r!Q![*r!^!_+`!c!}*r#T#o*r~+`Od~~+eOg~~+hUO!}+e#O#P+e#P#Q+z#Q;'S+e;'S;=`,P<%lO+e~,PO[~~,SP;=`<%l+e~,[O]~~,aW^~xy+Z}!O*r!Q![*r!^!_+`!c!}*r#T#g*r#g#h,y#h#o*r~-OW^~xy+Z}!O*r!Q![*r!^!_+`!c!}*r#T#]*r#]#^-h#^#o*r~-mW^~xy+Z}!O*r!Q![*r!^!_+`!c!}*r#T#b*r#b#c.V#c#o*r~.[W^~xy+Z}!O*r!Q![*r!^!_+`!c!}*r#T#Z*r#Z#[.t#[#o*r~.yU^~xy+Z}!O/]!Q![*r!^!_+`!c!}*r#T#o*r~/bW^~xy+Z}!O*r!Q![*r!^!_+`!c!}*r#T#k*r#k#l/z#l#o*r~0PW^~xy+Z}!O*r!Q![*r!^!_+`!c!}*r#T#c*r#c#d0i#d#o*r~0nW^~xy+Z}!O*r!Q![*r!^!_+`!c!}*r#T#f*r#f#g1W#g#o*r~1]W^~xy+Z}!O*r!Q![*r!^!_+`!c!}*r#T#W*r#W#X1u#X#o*r~1zW^~xy+Z}!O*r!Q![*r!^!_+`!c!}*r#T#g*r#g#h2d#h#o*r~2iU^~xy+Z}!O2{!Q![*r!^!_+`!c!}*r#T#o*r~3QW^~xy+Z}!O*r!Q![*r!^!_+`!c!}*r#T#Y*r#Y#Z3j#Z#o*r~3oW^~xy+Z}!O*r!Q![*r!^!_+`!c!}*r#T#f*r#f#g4X#g#o*r~4^W^~xy+Z}!O*r!Q![*r!^!_+`!c!}*r#T#c*r#c#d4v#d#o*r~4{W^~xy+Z}!O*r!Q![*r!^!_+`!c!}*r#T#a*r#a#b5e#b#o*r~5lU`~^~xy+Z}!O*r!Q![*r!^!_+`!c!}*r#T#o*r",
  tokenizers: [frontMatter, elisionMsg, 1, new lr.LocalTokenGroup("u~RRYZ[]^az{i~aOs~~fPs~YZ[~lP!P!Qo~tOt~~", 36, 34)],
  topRules: {"Program":[0,4]},
  tokenPrec: 236
});

/**
 * @public Rainlang syntax highlighter
 */
const RainlangLR = language.LRLanguage.define({
    name: "rainlang",
    parser: parser.configure({
        wrap: common.parseMixed((node, _input) => node.type.id == FrontMatter
            ? { parser: langYaml.yamlLanguage.parser, overlay: [{ from: node.from, to: node.to }] }
            : null)
    }),
    languageData: {
        closeBrackets: { brackets: ["(", "<", "[", "\"", "{", "`"] },
        commentTokens: { block: { open: "/*", close: "*/" } },
        wordChars: "-"
    }
});

/**
 * @public Converts TextDocument to TextDocumentItem
 */
function toTextDocumentItem(textDocument) {
    return {
        text: textDocument.getText(),
        uri: textDocument.uri,
        version: textDocument.version,
        languageId: textDocument.languageId
    };
}
// const useLast = (values: readonly any[]) => values.reduce((_, v) => v, '');
// const documentUri = Facet.define<string, string>({ combine: useLast });
// const languageId = Facet.define<string, string>({ combine: useLast });
/**
 * @public A plugin that manages languages services processes.
 * Original code from [codemirror-languageserver](https://github.com/FurqanSoftware/codemirror-languageserver),
 * BSD-3-Clause License, Copyright (c) 2021, Mahmud Ridwan, All rights reserved.
 *
 * @see [LICENSE](./LICENSE) for license details.
 */
class RainLanguageServicesPlugin {
    view;
    callback;
    uri = "file:///untitled.rain";
    languageId = "rainlang";
    metaStore;
    version = 0;
    langServices;
    textDocument;
    /**
     * @public constructor of the class
     * @param view - The editor view instance
     * @param metaStore - (optional) The meta store object to use
     * @param callback - (optional) The callback to run fork calls on native parser,
     * this will be called everytime there are no active diagnostics, so as a result,
     * errors from calling onchain parser will be shown as diagnostics
     */
    constructor(view, metaStore, callback) {
        this.view = view;
        this.callback = callback;
        this.metaStore = metaStore ? metaStore : new dotrain.MetaStore(true);
        this.textDocument = vscodeLanguageserverTextdocument.TextDocument.create(this.uri, this.languageId, this.version, this.view.state.doc.toString());
        this.langServices = new dotrain.RainLanguageServices(this.metaStore);
        this.processDiagnostics(this.view.state.doc.toString(), this.version).then(v => this.view.dispatch(v[0]));
    }
    // update the instance of TexTdocument and RainDocument
    update(update) {
        if (!update.docChanged)
            return;
        else {
            vscodeLanguageserverTextdocument.TextDocument.update(this.textDocument, [{ text: this.view.state.doc.toString() }], ++this.version);
            this.processDiagnostics(this.view.state.doc.toString(), this.version).then(v => v[1] === this.version ? this.view.dispatch(v[0]) : {});
        }
    }
    destroy() { }
    /**
     * @public Handles calls for hover tooltip
     */
    async handleHoverTooltip(offset) {
        try {
            const hover = this.langServices.doHover(toTextDocumentItem(this.textDocument), this.textDocument.positionAt(offset));
            if (!hover)
                return null;
            else {
                let end;
                if (hover.range) {
                    offset = this.textDocument.offsetAt(hover.range.start);
                    end = this.textDocument.offsetAt(hover.range.end);
                }
                return getHoverTooltip(hover, offset, end);
            }
        }
        catch (err) {
            console.log(err);
            return null;
        }
    }
    /**
     * @public Handles calls for code completion
     */
    async handleCompletion(context) {
        try {
            const completions = this.langServices.doComplete(toTextDocumentItem(this.textDocument), this.textDocument.positionAt(context.pos));
            if (!completions)
                return null;
            else
                return getCompletion(context, completions);
        }
        catch (err) {
            console.log(err);
            return null;
        }
    }
    /**
     * @public Handles calls for docuement diagnostics
     */
    async processDiagnostics(text, version) {
        try {
            const textDocument = dotrain.TextDocumentItem.create("file:///temp.rain", "rainlang", 0, text);
            const rainDocument = this.langServices.newRainDocument(textDocument);
            const diagnostics = getDiagnostics(rainDocument.allProblems);
            if (diagnostics.length === 0 && this.callback) {
                const npErrors = await this.callback(rainDocument);
                return [lint.setDiagnostics(this.view.state, getDiagnostics(npErrors)), version];
            }
            else {
                return [lint.setDiagnostics(this.view.state, diagnostics), version];
            }
        }
        catch (err) {
            console.log(err);
            return [lint.setDiagnostics(this.view.state, []), version];
        }
    }
}
/**
 * @public A plugin that gets all lang services through provided callbacks.
 * So all the logic behind suppliying the lang services results can be out-sources
 * on the callbacks implementations.
 * Each callback is triggered when the services is on demand in the text editor
 * through use input/actions
 */
class RawRainLanguageServicesPlugin {
    view;
    callbacks;
    uri = "file:///untitled.rain";
    languageId = "rainlang";
    version = 0;
    textDocument;
    constructor(view, callbacks) {
        this.view = view;
        this.callbacks = callbacks;
        this.textDocument = vscodeLanguageserverTextdocument.TextDocument.create(this.uri, this.languageId, this.version, this.view.state.doc.toString());
        this.processDiagnostics(this.view.state.doc.toString(), this.version).then(v => this.view.dispatch(v[0]));
    }
    // update the instance of TexTdocument and RainDocument
    update(update) {
        if (!update.docChanged)
            return;
        else {
            vscodeLanguageserverTextdocument.TextDocument.update(this.textDocument, [{ text: this.view.state.doc.toString() }], ++this.version);
            this.processDiagnostics(this.view.state.doc.toString(), this.version).then(v => v[1] === this.version ? this.view.dispatch(v[0]) : {});
        }
    }
    destroy() { }
    /**
     * @public Handles calls for hover tooltip
     */
    async handleHoverTooltip(offset) {
        if (this.callbacks.hover) {
            try {
                const hover = await this.callbacks.hover(toTextDocumentItem(this.textDocument), this.textDocument.positionAt(offset));
                if (!hover)
                    return null;
                else {
                    let end;
                    if (hover.range) {
                        offset = this.textDocument.offsetAt(hover.range.start);
                        end = this.textDocument.offsetAt(hover.range.end);
                    }
                    return getHoverTooltip(hover, offset, end);
                }
            }
            catch (err) {
                console.log(err);
                return null;
            }
        }
        else
            return null;
    }
    /**
     * @public Handles calls for code completion
     */
    async handleCompletion(context) {
        if (this.callbacks.completion) {
            try {
                const completions = await this.callbacks.completion(toTextDocumentItem(this.textDocument), this.textDocument.positionAt(context.pos));
                if (!completions)
                    return null;
                else
                    return getCompletion(context, completions);
            }
            catch (err) {
                console.log(err);
                return null;
            }
        }
        else
            return null;
    }
    /**
     * @public Handles calls for docuement diagnostics
     */
    async processDiagnostics(text, version) {
        try {
            const textDocument = dotrain.TextDocumentItem.create("file:///temp.rain", "rainlang", 0, text);
            const diagnostics = await this.callbacks.diagnostics(textDocument);
            return [lint.setDiagnostics(this.view.state, getDiagnostics(diagnostics)), version];
        }
        catch (err) {
            console.log(err);
            return [lint.setDiagnostics(this.view.state, []), version];
        }
    }
}
/**
 * @public Converts LSP hover to codemirror hover tooltips.
 * Original code from [codemirror-languageserver](https://github.com/FurqanSoftware/codemirror-languageserver),
 * BSD-3-Clause License, Copyright (c) 2021, Mahmud Ridwan, All rights reserved.
 *
 * @see [LICENSE](./LICENSE) for license details.
 *
 * @param hover - The LSP hover item
 * @param pos - Offset of the textDocument to get the completion items for
 * @param end - The end offset of the requested hiver item
 * @returns Codemirror tooltip or null
 */
function getHoverTooltip(hover, pos, end) {
    const { contents } = hover;
    if (pos === null)
        return null;
    const dom = document.createElement("div");
    dom.classList.add("documentation");
    //if (this.allowHTMLContent) dom.innerHTML = formatContents(contents);
    //else 
    dom.textContent = contents.value;
    return { pos, end, create: (_view) => ({ dom }), above: true };
}
/**
 * @public Converts LSP CompletionItem to codemirror code completions.
 * Original code from [codemirror-languageserver](https://github.com/FurqanSoftware/codemirror-languageserver),
 * BSD-3-Clause License, Copyright (c) 2021, Mahmud Ridwan, All rights reserved.
 *
 * @see [LICENSE](./LICENSE) for license details.
 *
 * @param context - Completion context
 * @param completionItems - The LSP completion items
 * @returns Codemirror completion result or null
 */
function getCompletion(context, completionItems) {
    const CompletionItemKindMap = Object.fromEntries(Object.entries(dotrain.CompletionItemKind).map(([key, value]) => [value, key]));
    let { pos } = context;
    if (!context.matchBefore(/['\w-]+$/))
        return null;
    let completions = completionItems.map(({ detail, label, kind, insertText, documentation, sortText, filterText, }) => {
        const completion = {
            label,
            detail,
            apply: insertText ? insertText : label,
            type: kind && CompletionItemKindMap[kind].toLowerCase(),
            sortText: sortText ?? label,
            filterText: filterText ?? label,
        };
        if (documentation) {
            completion.info = documentation.value;
        }
        return completion;
    });
    const [_span, _match] = prefixMatch(completions);
    const token = context.matchBefore(_match);
    if (token) {
        pos = token.from;
        const word = token.text.toLowerCase();
        if (/^['\w-]+$/.test(word)) {
            completions = completions
                .filter(({ filterText }) => filterText.toLowerCase().startsWith(word))
                .sort(({ label: a }, { label: b }) => {
                switch (true) {
                    case a.startsWith(token.text) && !b.startsWith(token.text):
                        return -1;
                    case !a.startsWith(token.text) && b.startsWith(token.text):
                        return 1;
                }
                return 0;
            });
        }
    }
    return {
        from: pos,
        options: completions,
    };
}
/**
 * @public Converts RainDocument Problems to codemirror diagnostics
 * @param problems - RainDocument problems
 */
function getDiagnostics(problems) {
    return problems.map(({ msg, position }) => ({
        message: msg,
        from: position[0],
        to: position[1],
        severity: "error"
        // ({
        //     [DiagnosticSeverity.Error]: "error",
        //     [DiagnosticSeverity.Warning]: "warning",
        //     [DiagnosticSeverity.Information]: "info",
        //     [DiagnosticSeverity.Hint]: "info",
        // } as const)[severity!]
    }));
}
/**
 * @public Converts a position to offset of a character in a codemirror text.
 * Original code from [codemirror-languageserver](https://github.com/FurqanSoftware/codemirror-languageserver),
 * BSD-3-Clause License, Copyright (c) 2021, Mahmud Ridwan, All rights reserved.
 *
 * @see [LICENSE](./LICENSE) for license details.
 *
 * @param doc - Codemirror text
 * @param pos - The position to convert
 * @returns - The offset of the provided position
 */
function posToOffset(doc, pos) {
    if (pos.line >= doc.lines)
        return doc.length;
    const offset = doc.line(pos.line + 1).from + pos.character;
    if (offset > doc.length)
        return doc.length;
    return offset;
}
/**
 * @public Converts offset of a character in a codemirror text to a position.
 * Original code from [codemirror-languageserver](https://github.com/FurqanSoftware/codemirror-languageserver),
 * BSD-3-Clause License, Copyright (c) 2021, Mahmud Ridwan, All rights reserved.
 *
 * @see [LICENSE](./LICENSE) for license details.
 *
 * @param doc - Codemirror text
 * @param offset - The offset to convert
 * @returns - The position of the provided character offset
 */
function offsetToPos(doc, offset) {
    const line = doc.lineAt(offset);
    return {
        line: line.number - 1,
        character: offset - line.from,
    };
}
/**
 * @public Constructs regexp out of completion items.
 * Original code from [codemirror-languageserver](https://github.com/FurqanSoftware/codemirror-languageserver),
 * BSD-3-Clause License, Copyright (c) 2021, Mahmud Ridwan, All rights reserved.
 *
 * @see [LICENSE](./LICENSE) for license details.
 *
 * @param completions - Codemirror completion items
 * @returns Regexp of completion items
 */
function prefixMatch(completions) {
    function toSet(chars) {
        let preamble = "";
        let flat = Array.from(chars).join("");
        const words = /\w/.test(flat);
        if (words) {
            preamble += "\\w";
            flat = flat.replace(/\w/g, "");
        }
        return `[${preamble}${flat.replace(/[^\w\s]/g, "\\$&")}]`;
    }
    const first = new Set();
    const rest = new Set();
    for (const { label } of completions) {
        const [initial, ...restStr] = label;
        first.add(initial);
        for (const char of restStr) {
            rest.add(char);
        }
    }
    const source = toSet(first) + toSet(rest) + "*$";
    return [new RegExp("^" + source), new RegExp(source)];
}
/**
 * @public Reduces an array to its last element
 * @param values - Values to reduce
 */
const useLast = (values) => values.reduce((_, v) => v, "");

/**
 * @public The facet used to store and retrive RainLanguageServicesPlugin instance from a EditorView.plugin().
 * By getting the facet value from the state associated with that EditoreView instance, you then can intract
 * with the plugin directly to get the Meta.Store instance and update its subgraph and metas manually, however,
 * this is not recommended as the meta storage and management is handled automatically by every meta hash that
 * is specified in an Rain document, so using this will not be needed in most of the cases unless some custom
 * behavior is intended.
 * This combination is provided for `rainlang` LanguageSupport class object and not for `RainlangExtention` class.
 *
 * @example
 * ```typescript
 * // get value of the facet
 * const rainViewPlugin = editorView.state.facet(RainLanguageServicesFacet);
 *
 * // get the plugin instance
 * const rainPlugin = editorView.plugin(rainViewPlugin);
 *
 * // update op meta from plugin
 * rainPlugin.getMetaStore();
 * ```
 */
const RainLanguageServicesFacet = state.Facet.define({ combine: useLast });
/**
 * @public Rainlang as a codemirror extension
 * @example
 * ```typescript
 * // instantiate the extension that can be directly used as codemirror extension
 * const rainlangExtension = new RainlangExtention(options);
 *
 * // instantiate the extension with initial meta data
 * const rainlangExtension = new RainlangExtension();
 *
 * // to get the MetaStore instance of this extension instance
 * const metaStore = rainlangExtension.plugin.metaStore;
 * ```
 */
class RainlangExtension extends language.LanguageSupport {
    plugin;
    hover = view.hoverTooltip((_view, pos) => this.plugin?.handleHoverTooltip(pos) ?? null);
    completion = autocomplete.autocompletion({
        override: [
            async (context) => {
                if (this.plugin == null)
                    return null;
                return await this.plugin?.handleCompletion(context);
            },
        ],
    });
    /**
     * @public Constructor of the RainlangCodemirror class
     * @param config - Options for language services to include
     */
    constructor(config) {
        const rainViewPlugin = view.ViewPlugin.define(view => this.plugin = new RainLanguageServicesPlugin(view, config?.metaStore, config?.callback));
        const ext = [
            langYaml.yaml().support,
            RainLanguageServicesFacet.of(rainViewPlugin),
            rainViewPlugin
        ];
        super(RainlangLR, ext);
        if (!config)
            ext.push(this.hover, this.completion);
        else {
            if (config?.hover)
                ext.push(this.hover);
            if (config?.completion)
                ext.push(this.completion);
        }
    }
}
/**
 * @public Raw Rainlang codemirror extension, that does everything through supplied callbacks
 */
class RawRainlangExtension extends language.LanguageSupport {
    plugin;
    hover = view.hoverTooltip((_view, pos) => this.plugin?.handleHoverTooltip(pos) ?? null);
    completion = autocomplete.autocompletion({
        override: [
            async (context) => {
                if (this.plugin == null)
                    return null;
                return await this.plugin?.handleCompletion(context);
            },
        ],
    });
    /**
     * @public Constructor of the RainlangCodemirror class
     * @param callbacks - Raw language services callbacks
     */
    constructor(callbacks) {
        const rainViewPlugin = view.ViewPlugin.define(view => this.plugin = new RawRainLanguageServicesPlugin(view, callbacks));
        const ext = [
            langYaml.yaml().support,
            RainLanguageServicesFacet.of(rainViewPlugin),
            rainViewPlugin
        ];
        super(RainlangLR, ext);
        if (callbacks.hover)
            ext.push(this.hover);
        if (callbacks.completion)
            ext.push(this.completion);
    }
}
/**
 * @public
 * Provides Rainlang implementation for codemirror as LanguageSupport
 * This is the standard implementation of rainlang for codemirror.
 *
 * @example
 * ```typescript
 * const rainLanguageSupport = RainLanguageSupport(config);
 * ```
 * in order to get the Meta.Store instance, it should be done through getting the plugin instance
 * from the EditorView with providing it the result of getting the `RainLanguageServicesFacet`
 * facet and then calling `getMetaStore()` for it, however this is not recommended as meta management
 * is done automatically from specified meta hashes in a Rain document:
 * ```typescript
 * // get the `RainLanguageServicesFacet` value from editor view
 * const rainViewPlugin = view.state.facet(RainLanguageServicesFacet);
 *
 * // retrive the `RainLanguageServicesPlugin` instance
 * const rainPlugin = view.plugin(rainViewPlugin);
 *
 * // get the Meta.Store instance
 * rainPlugin.metaStore();
 * ```
 *
 * @param config - Options for language services to include
 * @param metaStore - (optional) The meta store object to use
 * @returns rainlang LanguageSupport
 */
function RainLanguageSupport(config) {
    let plugin;
    const rainViewPlugin = view.ViewPlugin.define(view => plugin = new RainLanguageServicesPlugin(view, config?.metaStore, config?.callback));
    const services = [];
    const hover = view.hoverTooltip((_view, pos) => plugin?.handleHoverTooltip(pos) ?? null);
    const completion = autocomplete.autocompletion({
        override: [
            async (context) => {
                if (plugin == null)
                    return null;
                return await plugin?.handleCompletion(context);
            },
        ],
    });
    if (!config)
        services.push(hover, completion);
    else {
        if (config?.hover)
            services.push(hover);
        if (config?.completion)
            services.push(completion);
    }
    return new language.LanguageSupport(RainlangLR, [
        RainLanguageServicesFacet.of(rainViewPlugin),
        rainViewPlugin,
        langYaml.yaml().support,
        ...services
    ]);
}
/**
 * @public Provides LanguageDescription class object for rainlang.
 * Use `load` to instantiate rain LanguageSupport with initial meta data
 */
const RainlangDescription = language.LanguageDescription.of({
    name: "rainlang",
    alias: ["Rain Language", "Rainlang", "RainLang", "rain"],
    extensions: [".rain"],
    load: (config) => {
        return Promise.resolve(new RainlangExtension(config));
    },
    support: new RainlangExtension()
});

Object.defineProperty(exports, 'MetaStore', {
  enumerable: true,
  get: function () { return dotrain.MetaStore; }
});
Object.defineProperty(exports, 'TextDocument', {
  enumerable: true,
  get: function () { return vscodeLanguageserverTextdocument.TextDocument; }
});
exports.RainLanguageServicesFacet = RainLanguageServicesFacet;
exports.RainLanguageServicesPlugin = RainLanguageServicesPlugin;
exports.RainLanguageSupport = RainLanguageSupport;
exports.RainlangDescription = RainlangDescription;
exports.RainlangExtension = RainlangExtension;
exports.RainlangLR = RainlangLR;
exports.RawRainLanguageServicesPlugin = RawRainLanguageServicesPlugin;
exports.RawRainlangExtension = RawRainlangExtension;
exports.getCompletion = getCompletion;
exports.getDiagnostics = getDiagnostics;
exports.getHoverTooltip = getHoverTooltip;
exports.offsetToPos = offsetToPos;
exports.posToOffset = posToOffset;
exports.prefixMatch = prefixMatch;
exports.toTextDocumentItem = toTextDocumentItem;
exports.useLast = useLast;
Object.keys(dotrain).forEach(function (k) {
  if (k !== 'default' && !exports.hasOwnProperty(k)) Object.defineProperty(exports, k, {
    enumerable: true,
    get: function () { return dotrain[k]; }
  });
});
